/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2003 NextApp, Inc.
 *
 * Echo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Echo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package nextapp.echoservlet.resource;

/**
 * A container of resource name constants.
 */
public interface ResourceNames {

    static final String RESOURCE_PATH = "/nextapp/echoservlet/resource/";
    static final String STATIC_RESOURCE_PATH = RESOURCE_PATH + "static/";
    static final String TEMPLATE_RESOURCE_PATH = RESOURCE_PATH + "template/";

    public static final String BLANK_PIXEL             = STATIC_RESOURCE_PATH   + "BlankPixel.gif";
    public static final String BLANK_DOCUMENT          = STATIC_RESOURCE_PATH   + "BlankDocument.html";
    public static final String CHECK_BOX_OFF           = STATIC_RESOURCE_PATH   + "CheckBoxOff.gif";
    public static final String CHECK_BOX_ON            = STATIC_RESOURCE_PATH   + "CheckBoxOn.gif";
    public static final String RADIO_BUTTON_OFF        = STATIC_RESOURCE_PATH   + "RadioButtonOff.gif";
    public static final String RADIO_BUTTON_ON         = STATIC_RESOURCE_PATH   + "RadioButtonOn.gif";
    public static final String COLLECTIONS_SCRIPT      = STATIC_RESOURCE_PATH   + "Collections.js";
    public static final String CONTENT_PANE_SCRIPT     = STATIC_RESOURCE_PATH   + "ContentPane.js";
    public static final String CLIENT_MODEL_SCRIPT     = STATIC_RESOURCE_PATH   + "ClientModel.js";
    public static final String CONTROLLER_SCRIPT       = STATIC_RESOURCE_PATH   + "Controller.js";
    public static final String WINDOW_SCRIPT           = STATIC_RESOURCE_PATH   + "Window.js";
    public static final String IMAGE_SWAP_SCRIPT       = STATIC_RESOURCE_PATH   + "ImageSwap.js";
    public static final String CSS_SWAP_SCRIPT         = STATIC_RESOURCE_PATH   + "CssSwap.js";
    public static final String ROLLOVER_SCRIPT         = STATIC_RESOURCE_PATH   + "Rollover.js";
    public static final String TOGGLE_BUTTON_SCRIPT    = STATIC_RESOURCE_PATH   + "ToggleButton.js";
    public static final String SELECT_FIELD_SCRIPT     = STATIC_RESOURCE_PATH   + "SelectField.js";
    public static final String INIT_FRAME_SCRIPT       = STATIC_RESOURCE_PATH   + "InitFrame.js";
    public static final String LIST_BOX_SCRIPT         = STATIC_RESOURCE_PATH   + "ListBox.js";
    public static final String TEXT_FIELD_SCRIPT       = STATIC_RESOURCE_PATH   + "TextField.js";

    public static final String SAFE_INVOKE_DEFAULT_SCRIPT           = STATIC_RESOURCE_PATH + "SafeInvoke_Default.js";
    public static final String SAFE_INVOKE_EXCEPTION_SUPPORT_SCRIPT = STATIC_RESOURCE_PATH + "SafeInvoke_ExceptionSupport.js";
    
    public static final String CLIENT_ERROR_SCRIPT     = TEMPLATE_RESOURCE_PATH + "ClientError.js";
    public static final String CLIENT_DETECT           = TEMPLATE_RESOURCE_PATH + "ClientDetect.html";
    public static final String STARTUP_CONTAINER       = TEMPLATE_RESOURCE_PATH + "StartupContainer.html";
    public static final String SESSION_EXPIRED         = TEMPLATE_RESOURCE_PATH + "SessionExpired.html";

    public static final String CONTROLLER_DEBUG_SCRIPT = STATIC_RESOURCE_PATH + "ControllerDebug.js";
}
