/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2003 NextApp, Inc.
 *
 * Echo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Echo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* List */

function E_List_E_add(E_element) {
    this.E_contents[this.E_contents.length] = E_element;
}

function E_List_E_contains(E_element) {
    return this.E_indexOf(E_element) != -1;
}

function E_List_E_indexOf(E_element) {
    var E_i;

    for (E_i = 0; E_i < this.E_contents.length; ++E_i) {
        if (this.E_contents[E_i] == E_element) {
            return E_i;
        }
    }
    
    return -1;
}

function E_List_E_get(E_index) {
    return this.E_contents[E_index];
}

function E_List_E_remove(E_index) {
    var E_i;
    
    for (E_i = E_index; E_i < this.E_contents.length - 1; ++E_i) {
        this.E_contents[E_i] = this.E_contents[E_i + 1];
    }
    
    this.E_contents.length = this.E_contents.length - 1;
}

function E_List_E_size() {
    return this.E_contents.length;
}

function E_List() {
    this.E_contents = new Array(0);
    this.E_add = E_List_E_add;
    this.E_contains = E_List_E_contains;
    this.E_get = E_List_E_get;
    this.E_indexOf = E_List_E_indexOf;
    this.E_remove = E_List_E_remove;
    this.E_size = E_List_E_size;
}

/* Set */

function E_Set_E_add(E_element) {
    if (! this.E_list.E_contains(E_element)) {
        this.E_list.E_add(E_element);
    }
}

function E_Set_E_contains(E_element) {
    return this.E_list.E_contains(E_element);
}

function E_Set_E_get(E_element) {
    return this.E_list.E_get(E_element);
}

function E_Set_E_indexOf(E_element) {
    return this.E_list.E_indexOf(E_element);
}

function E_Set_E_remove(E_element) {
    var E_i = this.E_list.E_indexOf(E_element);
    if (E_i != -1) {
        this.E_list.E_remove(E_i);
    }
}

function E_Set_E_size() {
    return this.E_list.E_size();
}

function E_Set() {
    this.E_list = new E_List();
    this.E_add = E_Set_E_add;
    this.E_contains = E_Set_E_contains;
    this.E_get = E_Set_E_get;
    this.E_indexOf = E_Set_E_indexOf;
    this.E_remove = E_Set_E_remove;
    this.E_size = E_Set_E_size;
}

/* Map */

function E_Map_E_get(E_key) {
    if (this.E_keys.E_contains(E_key)) {
        return this.E_values[E_key];
    } else {
        return null;
    }
}

function E_Map_E_keySet() {
    return this.E_keys;
}

function E_Map_E_put(E_key, E_value) {
    this.E_keys.E_add(E_key);
    this.E_values[E_key] = E_value;
}

function E_Map_E_remove(E_key) {
    if (this.E_keys.E_contains(E_key)) {
        this.E_keys.E_remove(E_key);
        this.E_values[E_key] = null;
    }
}

function E_Map_E_size() {
    return this.E_keys.E_size();
}

function E_Map() {
    this.E_keys = new E_Set();
    this.E_values = new Array();
    this.E_get = E_Map_E_get;
    this.E_keySet = E_Map_E_keySet;
    this.E_put = E_Map_E_put;
    this.E_remove = E_Map_E_remove;
    this.E_size = E_Map_E_size;
}
