/* 
 * This file is part of the Echo Web Application Framework (hereinafter "Echo").
 * Copyright (C) 2002-2003 NextApp, Inc.
 *
 * Echo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Echo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var E_rootFrame = null;
 
function E_focusByElementId(E_id) {
    var E_element = document.getElementById(E_id);
    if (E_element != null) {
        E_element.focus();
    }
} 
 
/**
 * Returns the controller frame if it is ready, and null if it is not.
 */
function E_getController() {
    var E_root = E_getRoot();
    if (E_root && E_root.E_getClientModel && E_root.E_getClientModel() && E_root.E_getClientModel().E_getController) {
        var E_controller = E_root.E_getClientModel().E_getController();
        if (E_controller && E_controller.E_ready) {
            return E_controller;
        } else {
            return null;
        }
    } else {
        return null;
    }
}

function E_isApplicationWindowRootContent() {
    return top.E_rootFrame;
}

/**
 * Returns the root frame of the Echo application.
 */
function E_getRoot() {
    if (E_rootFrame != null) {
        return E_rootFrame;
    }
    
    if (E_try(null, "E_isApplicationWindowRootContent")) {
        E_rootFrame = top;
    } else {
        var E_testFrame = window;
        while (E_testFrame.parent != null && E_testFrame.parent != E_testFrame) {
            if (E_testFrame.E_rootFrame) {
                E_rootFrame = E_testFrame;
            }
            E_testFrame = E_testFrame.parent;
        }
        // For testing only.
        // alert("Cannot retrieve root frame");
    }
    
    return E_rootFrame;
}

/**
 * Returns the value in the controller form's parameter field for E_id.
 * If the controller is not ready, null is returned.
 */
function E_getParameter(E_id) {
    var E_controller = E_getController();
    
    if (E_controller) {
        return E_controller.E_getParameter(E_id);
    } else {
        return null;
    }
}

/**
 * Sets the value in controller form's parameter field for E_id.
 * Returns true if the controller form was ready and the field was set,
 * and false if it was not.
 */
function E_setParameter(E_id, E_value) {
    var E_controller = E_getController();

    if (E_controller) {
        E_controller.E_setParameter(E_id, E_value);
        return true;
    } else {
        return false;
    }
}

/**
 * Sets the action command, causing the controller frame to submit.  
 */
function E_setAction(E_id, E_command) {
    var E_controller = E_getController();

    if (E_controller) {
        E_controller.E_setAction(E_id, E_command);
    } else {
        E_alertNotReady();
    }
}
